/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class UnknownQueryLanguage extends org.apache.thrift.TException implements org.apache.thrift.TBase<UnknownQueryLanguage, UnknownQueryLanguage._Fields>, java.io.Serializable, Cloneable, Comparable<UnknownQueryLanguage> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("UnknownQueryLanguage");

  private static final org.apache.thrift.protocol.TField QUERY_LANGUAGE_FIELD_DESC = new org.apache.thrift.protocol.TField("queryLanguage", org.apache.thrift.protocol.TType.STRING, (short)1);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new UnknownQueryLanguageStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new UnknownQueryLanguageTupleSchemeFactory();

  public @org.apache.thrift.annotation.Nullable java.lang.String queryLanguage; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    QUERY_LANGUAGE((short)1, "queryLanguage");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // QUERY_LANGUAGE
          return QUERY_LANGUAGE;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final _Fields optionals[] = {_Fields.QUERY_LANGUAGE};
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.QUERY_LANGUAGE, new org.apache.thrift.meta_data.FieldMetaData("queryLanguage", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(UnknownQueryLanguage.class, metaDataMap);
  }

  public UnknownQueryLanguage() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public UnknownQueryLanguage(UnknownQueryLanguage other) {
    if (other.isSetQueryLanguage()) {
      this.queryLanguage = other.queryLanguage;
    }
  }

  public UnknownQueryLanguage deepCopy() {
    return new UnknownQueryLanguage(this);
  }

  @Override
  public void clear() {
    this.queryLanguage = null;
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getQueryLanguage() {
    return this.queryLanguage;
  }

  public UnknownQueryLanguage setQueryLanguage(@org.apache.thrift.annotation.Nullable java.lang.String queryLanguage) {
    this.queryLanguage = queryLanguage;
    return this;
  }

  public void unsetQueryLanguage() {
    this.queryLanguage = null;
  }

  /** Returns true if field queryLanguage is set (has been assigned a value) and false otherwise */
  public boolean isSetQueryLanguage() {
    return this.queryLanguage != null;
  }

  public void setQueryLanguageIsSet(boolean value) {
    if (!value) {
      this.queryLanguage = null;
    }
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case QUERY_LANGUAGE:
      if (value == null) {
        unsetQueryLanguage();
      } else {
        setQueryLanguage((java.lang.String)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case QUERY_LANGUAGE:
      return getQueryLanguage();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case QUERY_LANGUAGE:
      return isSetQueryLanguage();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof UnknownQueryLanguage)
      return this.equals((UnknownQueryLanguage)that);
    return false;
  }

  public boolean equals(UnknownQueryLanguage that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_queryLanguage = true && this.isSetQueryLanguage();
    boolean that_present_queryLanguage = true && that.isSetQueryLanguage();
    if (this_present_queryLanguage || that_present_queryLanguage) {
      if (!(this_present_queryLanguage && that_present_queryLanguage))
        return false;
      if (!this.queryLanguage.equals(that.queryLanguage))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + ((isSetQueryLanguage()) ? 131071 : 524287);
    if (isSetQueryLanguage())
      hashCode = hashCode * 8191 + queryLanguage.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(UnknownQueryLanguage other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetQueryLanguage()).compareTo(other.isSetQueryLanguage());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetQueryLanguage()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.queryLanguage, other.queryLanguage);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("UnknownQueryLanguage(");
    boolean first = true;

    if (isSetQueryLanguage()) {
      sb.append("queryLanguage:");
      if (this.queryLanguage == null) {
        sb.append("null");
      } else {
        sb.append(this.queryLanguage);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class UnknownQueryLanguageStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public UnknownQueryLanguageStandardScheme getScheme() {
      return new UnknownQueryLanguageStandardScheme();
    }
  }

  private static class UnknownQueryLanguageStandardScheme extends org.apache.thrift.scheme.StandardScheme<UnknownQueryLanguage> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, UnknownQueryLanguage struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // QUERY_LANGUAGE
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.queryLanguage = iprot.readString();
              struct.setQueryLanguageIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, UnknownQueryLanguage struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.queryLanguage != null) {
        if (struct.isSetQueryLanguage()) {
          oprot.writeFieldBegin(QUERY_LANGUAGE_FIELD_DESC);
          oprot.writeString(struct.queryLanguage);
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class UnknownQueryLanguageTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public UnknownQueryLanguageTupleScheme getScheme() {
      return new UnknownQueryLanguageTupleScheme();
    }
  }

  private static class UnknownQueryLanguageTupleScheme extends org.apache.thrift.scheme.TupleScheme<UnknownQueryLanguage> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, UnknownQueryLanguage struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetQueryLanguage()) {
        optionals.set(0);
      }
      oprot.writeBitSet(optionals, 1);
      if (struct.isSetQueryLanguage()) {
        oprot.writeString(struct.queryLanguage);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, UnknownQueryLanguage struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet incoming = iprot.readBitSet(1);
      if (incoming.get(0)) {
        struct.queryLanguage = iprot.readString();
        struct.setQueryLanguageIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

